# Distributed Locks

During save operations, Umbraco will generally take a database lock to avoid concurrency issues.

Access to this feature is via the `IScope` interface, for example:

```csharp
 using (var scope = _scopeProvider.CreateScope())
{
    scope.WriteLock(Constants.Locks.Domains);

    // Carry out save operation.

    scope.Complete();
}
```

Each lockable entity is represented by an integer Id, stored along with the state of the lock in the `umbracoLock` database table.

Packages or custom solutions working with custom data via the `IScope` interface can introduce their own records to this table. However it's important to not clash with either core identifiers or those introduced by other packages.

A reference is maintained here of known identifiers:

| Id           | Name                | Used By        |
| ------------ | ------------------- | -------------- |
| -1000        | MainDom             | Umbraco CMS    |
| -331 to -340 | Various             | Umbraco CMS    |
| -800         | DeployTransferQueue | Umbraco Deploy |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.umbraco.com/umbraco-cms/reference/distributed-locks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
